Subject: bug#28729: 26.0.60; Incorrect Edebug spec for gv-define-setter

From: Lars Ingebrigtsen <[email-masked]>
Date: Mon, 15 Jul 2019 11:16:24 +0200

Gemini Lasswell <[email-masked]> writes:

> The Edebug spec for gv-define-setter is incorrect. It should use
> :name, so Edebug doesn't confuse it with the getter, and it should use
> def-body instead of body. To reproduce the problem, put this bit of
> code into *scratch*:
>
> (defun obo-ref (a idx)
>   (aref a (1- idx)))
>
> (gv-define-setter obo-ref (val a idx)
>   `(aset ,a (1- ,idx) ,val))
>
> (defvar my-array [ 10 20 30 40 ])
>
> (defun set-first-elem (n)
>   (setf (obo-ref my-array 1) n))
>
> Then:
>
> M-x edebug-all-defs RET
> M-x eval-buffer RET
>
> Result: Eager macro-expansion failure: (wrong-type-argument consp nil)

I can confirm that changing `body' to `def-body' fixes this bug.

> M-: (obo-ref my-array 3) RET
> SPC SPC
>
> Result: Edebug starts stepping through the setter, then quits with
> "Source has changed - reevaluate definition of obo-ref".

This is till a problem.  I'm not sure what you mean by "It should use
:name" -- how does that work in edebug specs?  (I'm not particularly
familiar with edebug internals.)

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no